/*
	SourceMod Anti-Cheat Eye Test Module
	Copyright (C) 2011 GoD-Tony
	Copyright (C) 2011 Nicholas "psychonic" Hastings (nshastings@gmail.com)
	Copyright (C) 2007-2011 CodingDirect LLC

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

//- Global Variables -//

new Handle:g_hCVarEyeTest = INVALID_HANDLE;
new g_iEyeTestMode;
new bool:g_bEyeProcessing[MAXPLAYERS+1];

//- Plugin Functions -//

Eyetest_OnPluginStart()
{
	g_hCVarEyeTest = CreateConVar("smac_eyetest", "0", "Enable the eye test detection routine. (0 = Disabled, 1 = Warn Admins, 2 = Ban)");
	
	Eyetest_CvarChange(g_hCVarEyeTest, "", "");
	HookConVarChange(g_hCVarEyeTest, Eyetest_CvarChange);
}

Eyetest_OnClientDisconnect_Post(client)
{
	g_bEyeProcessing[client] = false;
}

public Eyetest_CvarChange(Handle:convar, const String:oldValue[], const String:newValue[])
{
	g_iEyeTestMode = GetConVarInt(convar);
}

Eyetest_OnPlayerRunCmd(client, Float:angles[3])
{
	if (!g_iEyeTestMode || g_bIsFake[client])
		return;
	
	// +/- normal limit * 1.5 as a buffer zone.
	if ( (angles[0] > 135.0 || angles[0] < -135.0 || angles[1] > 270.0 || angles[1] < -270.0)
		&& IsPlayerAlive(client) && !(GetEntityFlags(client) & FL_ATCONTROLS) )
		Eyetest_Detected(client, angles);
}

Eyetest_Detected(client, Float:angles[3])
{
	// Prevent a player from being detected multiple times while being processed.
	if (g_bEyeProcessing[client])
		return;
	
	g_bEyeProcessing[client] = true;
	
	new String:f_sName[64], String:f_sAuthID[64], String:f_sIP[64];
	GetClientName(client, f_sName, sizeof(f_sName));
	GetClientAuthString(client, f_sAuthID, sizeof(f_sAuthID));
	GetClientIP(client, f_sIP, sizeof(f_sIP));
	
	switch (g_iEyeTestMode)
	{
		case 1: // Warn Admins.
		{
			SMAC_Log("%N (ID: %s | IP: %s) is suspected of cheating with their eye angles. Eye Angles: %.0f %.0f %.0f", client, f_sAuthID, f_sIP, angles[0], angles[1], angles[2]);
			SMAC_PrintToChatAdmins("%t", SMAC_EYETESTDETECTED, f_sName);
		}
		case 2: // Ban.
		{
			SMAC_Log("%N (ID: %s | IP: %s) was banned for cheating with their eye angles. Eye Angles: %.0f %.0f %.0f", client, f_sAuthID, f_sIP, angles[0], angles[1], angles[2]);
			SMAC_Ban(client, 0, SMAC_BANNED, "SMAC: Eye Angles Violation");
		}
	}
}
